Index: Portfile
===================================================================
--- Portfile	(revision 52310)
+++ Portfile	(working copy)
@@ -1,29 +1,93 @@
+# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
 # $Id$
 
-PortSystem          1.0
-name                anjuta
-version             1.2.4a
-categories          gnome devel
-maintainers         nomaintainer
-description         A gnome ide.
-long_description    ${description}
+PortSystem      1.0
 
-platforms           darwin 
+name            anjuta
+version         2.26.2.0
+set branch      [join [lrange [split ${version} .] 0 1] .]
+description     A GNOME/GTK IDE
+long_description        ${description}
+maintainers     devans openmaintainer
+categories      gnome devel
+platforms       darwin
+homepage        http://anjuta.sourceforge.net/
+master_sites    gnome:sources/${name}/${branch}/
 
-homepage            http://anjuta.sourceforge.net/
-master_sites        sourceforge
+checksums       md5     16435dc99012e9799525e1fbdda35e79 \
+                sha1    b8d438f1938a8021143e6c410d61a4dc52fbdae7 \
+                rmd160  c612ff9515ebeae6a82b49285d40049f454b10dd
 
-checksums           md5 7e6af289b4bfd1ec2ca72e2017efc4d3
+patchfiles      patch-libanjuta-anjuta-launcher.c.diff \
+                patch-libanjuta-anjuta-utils.c.diff
 
-depends_lib         lib:libzvt-2:libzvt lib:libvte:vte lib:libpcreposix:pcre \
-                    lib:libgnomeprintui-2.2:libgnomeprintui
+depends_build   port:pkgconfig \
+                port:intltool \
+                port:p5-xml-parser \
+                port:gnome-doc-utils \
+                port:gtk-doc
 
-post-extract {
-   reinplace "s|-lutil||g" ${worksrcpath}/src/Makefile.in
+depends_lib     port:autogen \
+                port:gconf \
+                port:gdl \
+                port:libgda4 \
+                port:libunique \
+                port:vte
+
+post-patch {
+        reinplace "s|/usr/bin/perl|${prefix}/bin/perl|" ${worksrcpath}/scripts/glade2schema.pl
 }
 
-patchfiles          patch-parser.h patch-launcher.c
+configure.args  --enable-static \
+                --disable-scrollkeeper \
+                --disable-schemas-install \
+                --disable-plugin-devhelp \
+                --disable-plugin-glade \
+                --disable-graphviz \
+                --disable-plugin-sourceview \
+                --disable-plugin-valgrind \
+                --disable-plugin-subversion
 
-configure.cppflags-append   "-L${prefix}/lib"
-configure.cflags-append     "-no-cpp-precomp -L${prefix}/lib" 
+variant devhelp description {Enable devhelp plugin support} {
+                configure.args-delete   --disable-plugin-devhelp
+                depends_lib-append      port:devhelp
+}
 
+variant glade description {Enable glade plugin support} {
+                configure.args-delete   --disable-plugin-glade
+                depends_lib-append      port:glade3
+}
+
+variant graphviz description {Enable class inheritance plugin support using graphviz} {
+                configure.args-delete   --disable-graphviz
+                depends_lib-append      port:graphviz
+}
+
+variant sourceview description {Enable gtksourceview editor plugin support instead of scintilla} {
+                configure.args-append   --disable-plugin-scintilla
+                configure.args-delete   --disable-plugin-sourceview
+                depends_lib-append      port:gtksourceview2
+}
+
+variant subversion description {Enable subversion plugin support} {
+                configure.args-delete   --disable-plugin-subversion
+                configure.args-append   --with-subversion-dir=${prefix} \
+                                        --with-svn-include=${prefix}/include/subversion-1 \
+                                        --with-svn-lib=${prefix}/lib
+                depends_lib-append      port:subversion
+}
+
+post-destroot {
+        system "cd ${destroot}${prefix}/lib/anjuta && ln -s libfile-manager.dylib libfile-manager.so"
+}
+
+post-activate {
+        system "scrollkeeper-update"
+        system "export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source` && \
+             gconftool-2 --makefile-install-rule ${prefix}/etc/gconf/schemas/*.schemas"
+}
+
+livecheck.check regex
+livecheck.url   http://ftp.gnome.org/pub/gnome/sources/${name}/${branch}/
+livecheck.regex {LATEST-IS-(\d+(?:\.\d+)*)}
+